## feel++ 0.91.4

=== CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8 -*-
#
#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-11-29
#
#  Copyright (C) 2009-2010 Université Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
cmake_minimum_required (VERSION 2.6)

# guard against in-source builds

if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(FATAL_ERROR "In-source builds not allowed. Please make a new directory (called a build directory) and run CMake from there. You may need to remove CMakeCache.txt. ")
endif()

# guard against bad build-type strings

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_tolower)
if(    NOT cmake_build_type_tolower STREQUAL "debug"
   AND NOT cmake_build_type_tolower STREQUAL "release"
   AND NOT cmake_build_type_tolower STREQUAL "relwithdebinfo")
  message(FATAL_ERROR "Unknown build type \"${CMAKE_BUILD_TYPE}\". Allowed values are Debug, Release, RelWithDebInfo (case-insensitive).")
endif()


#SET( CMAKE_CXX_FLAGS "-pipe -Wall -O2 ")
#SET( CMAKE_C_FLAGS "-pipe -Wall -O2")

project (Feel++ C CXX Fortran)

macro(set_config_option VARNAME STRING)
  set(${VARNAME} TRUE)
  list(APPEND CONFIG_OPTIONS ${STRING})
  message(STATUS "Found " ${STRING})
endmacro(set_config_option)


OPTION(FEELPP_ENABLE_SVN "enable Feel++ looking up for svn information" OFF)
SET(FEELPP_SCM "svn")
FIND_PACKAGE(Subversion)
IF(FEELPP_ENABLE_SVN AND ( Subversion_FOUND AND EXISTS ${PROJECT_SOURCE_DIR}/.svn ) )
#IF ( Subversion_FOUND AND EXISTS ${PROJECT_SOURCE_DIR}/.svn )
  Subversion_WC_INFO(${PROJECT_SOURCE_DIR} Project)
  MESSAGE("Current revision is ${Project_WC_REVISION}")
  Subversion_WC_LOG(${PROJECT_SOURCE_DIR} Project)
  MESSAGE("Last changed log is ${Project_LAST_CHANGED_LOG}")
ELSE()
  FIND_PACKAGE(Git)
  if(FEELPP_ENABLE_SVN AND GIT_FOUND AND  EXISTS ${PROJECT_SOURCE_DIR}/.git )

    execute_process(
      COMMAND git rev-parse --verify -q --short git-svn
      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
      OUTPUT_VARIABLE GIT_COMMIT
      ERROR_VARIABLE GIT_COMMIT_error
      RESULT_VARIABLE GIT_COMMIT_result)
    if ( NOT ${GIT_COMMIT_result} EQUAL 0 )
      MESSAGE(SEND_ERROR "Command \"git rev-parse --verify -q --short git-svn\" failed with output:\n${GIT_COMMIT_error}")
    else()
      STRING(STRIP "${GIT_COMMIT}" GIT_COMMIT )
      MESSAGE(STATUS "Git commit: ${GIT_COMMIT}")
    endif()
    execute_process(
      COMMAND git show --raw ${GIT_COMMIT}
#      COMMAND "grep git-svn-id"
#      COMMAND sed -re "s/^\\s*git-svn-id: .*@([0-9]+).*$/\\1/"
      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
      OUTPUT_VARIABLE SVN_COMMIT
      ERROR_VARIABLE Project_WC_REVISION_error
      RESULT_VARIABLE Project_WC_REVISION_result)
    if ( NOT ${Project_WC_REVISION_result} EQUAL 0 )
      MESSAGE(SEND_ERROR "Command \"git show --raw ${GIT_COMMIT}\" failed with output:\n${Project_WC_REVISION_error}")
    endif()
    string(REGEX REPLACE ".*git-svn-id: .*trunk@([0-9]+) .*" "\\1"Project_WC_REVISION ${SVN_COMMIT})
    MESSAGE(STATUS "Current SVN(git) revision is ${Project_WC_REVISION}")
  endif()
ENDIF()

set(FEELPP_VERSION_MAJOR "0")
set(FEELPP_VERSION_MINOR "91")
set(FEELPP_VERSION_MICRO "4")
set(FEELPP_REVISION "0" )
set(FEELPP_BUILDID "0" )
if ((FEELPP_ENABLE_SVN AND Subversion_FOUND AND EXISTS ${PROJECT_SOURCE_DIR}/.svn) OR
    (FEELPP_ENABLE_SVN AND GIT_FOUND AND  EXISTS ${PROJECT_SOURCE_DIR}/.git ))
  set(FEELPP_VERSION_EXTRA "~${FEELPP_SCM}${Project_WC_REVISION}")
  set(FEELPP_REVISION "${Project_WC_REVISION}")
  set(FEELPP_BUILDID "${Project_WC_REVISION}")
  file(WRITE "${CMAKE_SOURCE_DIR}/SVNREVISION" "${Project_WC_REVISION}")
else()
  set(FEELPP_VERSION_EXTRA "")
  if ( EXISTS "${CMAKE_SOURCE_DIR}/SVNREVISION" )
    file(READ "${CMAKE_SOURCE_DIR}/SVNREVISION" FEELPP_REVISION)
    file(READ "${CMAKE_SOURCE_DIR}/SVNREVISION" FEELPP_BUILDID)
  endif()
endif()
set(FEELPP_VERSION "(((${FEELPP_VERSION_MAJOR}) << 16) | ((${FEELPP_VERSION_MINOR}) << 9) | (${FEELPP_VERSION_MICRO}))" )
set(FEELPP_VERSION_STRING "${FEELPP_VERSION_MAJOR}.${FEELPP_VERSION_MINOR}.${FEELPP_VERSION_MICRO}${FEELPP_VERSION_EXTRA}")
set(FEELPP_SHARED_VERSION "1.0.0" )
set(FEELPP_SHARED_SOVERSION "1" )

SET(FEELPP_HOME_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")
SET(FEELPP_HOME_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")
SET(FEELPP_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")
SET(FEELPP_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")
SET(FEELPP_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR} CACHE INTERNAL "")

SET( CMAKE_MODULE_PATH  ${FEELPP_HOME_DIR}/cmake/modules )
add_subdirectory(cmake/modules)

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)


if(APPLE)
  set(FEELPP_OS "MacOSX")
elseif(CYGWIN)
  set(FEELPP_OS "Windows")
else(APPLE)
  set(FEELPP_OS "${CMAKE_SYSTEM_NAME}")
endif(APPLE)

if(CMAKE_COMPILER_IS_GNUCXX)
  SET(CMAKE_CXX_FLAGS "-std=c++0x -pedantic  -ftemplate-depth-256 -Wno-inline" CACHE STRING "Default flags" FORCE)
  SET(CMAKE_CXX_FLAGS_DEBUG "-std=c++0x  -pedantic -g  -ftemplate-depth-256 -Wno-inline" CACHE STRING "Debug flags" FORCE)
  SET(CMAKE_CXX_FLAGS_RELEASE "-std=c++0x  -pedantic -g0 -O2 -DNDEBUG  -ftemplate-depth-256 -finline-functions -Wno-inline"  CACHE STRING "Release flags" FORCE)
endif(CMAKE_COMPILER_IS_GNUCXX)

OPTION(FEELPP_ENABLE_MOVE_SEMANTICS "enable move semantics(elision)" ON )
MARK_AS_ADVANCED(FEELPP_ENABLE_MOVE_SEMANTICS)
IF ( FEELPP_ENABLE_MOVE_SEMANTICS )
  SET( BOOST_UBLAS_MOVE_SEMANTICS 1 CACHE STRING "Enable Boost Ublas move semantics" FORCE )
  ADD_DEFINITIONS( -DBOOST_UBLAS_MOVE_SEMANTICS )
ENDIF( FEELPP_ENABLE_MOVE_SEMANTICS )


OPTION(FEELPP_ENABLE_INSTANTIATION_MODE "Instantiation mode" ON )
MARK_AS_ADVANCED(FEELPP_ENABLE_INSTANTIATION_MODE)
IF ( FEELPP_ENABLE_INSTANTIATION_MODE )
  SET( FEELPP_INSTANTIATION_MODE 1 )
ENDIF()

OPTION(FEELPP_ENABLE_MPI_MODE "Instantiation mode" OFF )
IF ( FEELPP_ENABLE_MPI_MODE )
  SET( FEELPP_ENABLE_MPI_MODE 1 )
ENDIF()

OPTION(FEELPP_BENCHMARK_FLAGS "enable benchmarks flags" OFF)
if ( FEELPP_BENCHMARK_FLAGS )
  set(CMAKE_BUILD_TYPE Release )
  set(GCC_PARAM_INLINE_UNIT_GROWTH 150)
  set(GCC_PARAM_MAX_INLINE_INSNS_SINGLE 500)
  set(GCC_PARAM_LARGE_FUNCTION_GROWTH 600)
#  SET(CMAKE_CXX_FLAGS_RELEASE "-Wall -Wshadow -Woverloaded-virtual -std=c++0x -O3 -DNDEBUG --param max-inline-recursive-depth=256 --param max-gcse-memory=8000 --param max-inline-insns-single=${GCC_PARAM} --param inline-unit-growth=${GCC_PARAM} --param large-unit-insns=${GCC_PARAM} --param large-function-growth=${GCC_PARAM} --param large-function-insns=${GCC_PARAM} " CACHE STRING "Benchmarks Release flags" FORCE)
#  SET(CMAKE_CXX_FLAGS_RELEASE "-std=c++0x -O3 -DNDEBUG --param max-inline-recursive-depth=256 --param max-gcse-memory=8000 --param max-inline-insns-single=${GCC_PARAM} --param inline-unit-growth=${GCC_PARAM} --param large-unit-insns=${GCC_PARAM} --param large-function-growth=${GCC_PARAM} --param large-function-insns=${GCC_PARAM} " CACHE STRING "Benchmarks Release flags" FORCE)
  SET(CMAKE_CXX_FLAGS_RELEASE "-std=c++0x -O3 -DNDEBUG --param max-inline-insns-single=${GCC_PARAM_MAX_INLINE_INSNS_SINGLE} --param inline-unit-growth=${GCC_PARAM_INLINE_UNIT_GROWTH} --param large-function-growth=${GCC_PARAM_LARGE_FUNCTION_GROWTH} " CACHE STRING "Benchmarks Release flags" FORCE)
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
  option(FEELPP_ENABLE_SSE2 "Enable/Disable SSE2 in tests/examples" OFF)
  if(FEELPP_ENABLE_SSE2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
    message(STATUS "Enabling SSE2 in tests/examples")
  endif()

  option(FEELPP_ENABLE_SSE3 "Enable/Disable SSE3 in tests/examples" OFF)
  if(FEELPP_ENABLE_SSE3)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse3")
    message(STATUS "Enabling SSE3 in tests/examples")
  endif()

  option(FEELPP_ENABLE_SSSE3 "Enable/Disable SSSE3 in tests/examples" OFF)
  if(FEELPP_ENABLE_SSSE3)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mssse3")
    message(STATUS "Enabling SSSE3 in tests/examples")
  endif()

  option(FEELPP_ENABLE_SSE4_1 "Enable/Disable SSE4.1 in tests/examples" OFF)
  if(FEELPP_ENABLE_SSE4_1)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.1")
    message(STATUS "Enabling SSE4.1 in tests/examples")
  endif()

  option(FEELPP_ENABLE_SSE4_2 "Enable/Disable SSE4.2 in tests/examples" OFF)
  if(FEELPP_ENABLE_SSE4_2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.2")
    message(STATUS "Enabling SSE4.2 in tests/examples")
  endif()

  option(FEELPP_ENABLE_ALTIVEC "Enable/Disable AltiVec in tests/examples" OFF)
  if(FEELPP_ENABLE_ALTIVEC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -maltivec -mabi=altivec")
    message(STATUS "Enabling AltiVec in tests/examples")
  endif()

  option(FEELPP_ENABLE_NEON "Enable/Disable Neon in tests/examples" OFF)
  if(FEELPP_ENABLE_NEON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfloat-abi=softfp -mfpu=neon -mcpu=cortex-a8")
    message(STATUS "Enabling NEON in tests/examples")
  endif()
endif(CMAKE_COMPILER_IS_GNUCXX)
#INCLUDE(PackageArchGlobalMacros)
# INCLUDE(FeelGlobalMacros)
#INCLUDE(AdvancedSet)
#INCLUDE(AdvancedOption)

include(feelpp.extra.warnings)
add_definitions(${FEELPP_FLAGS})

if("${CMAKE_CXX_FLAGS} ${FEELPP_FLAGS}" MATCHES "[^ ]")
  message(STATUS "[feel++] Global flags: ${CMAKE_CXX_FLAGS} ${FEELPP_FLAGS}")
endif()

message(STATUS "[feel++] Debug flags: ${CMAKE_CXX_FLAGS_DEBUG}")
message(STATUS "[feel++] Release flags: ${CMAKE_CXX_FLAGS_RELEASE}")

INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckCXXSourceCompiles)
INCLUDE(CheckLibraryExists)
INCLUDE(ParseArguments)

# MACRO(CAR var)
#   SET(${var} ${ARGV1})
# ENDMACRO(CAR)

# MACRO(CDR var junk)
#   SET(${var} ${ARGN})
# ENDMACRO(CDR)
INCLUDE(CheckTypeSize)
CHECK_TYPE_SIZE(int SIZE_INT )
CHECK_TYPE_SIZE(uint SIZE_UINT )
CHECK_TYPE_SIZE(size_t SIZE_SIZE_T )
CHECK_TYPE_SIZE(long SIZE_LONG )
CHECK_TYPE_SIZE(float SIZE_FLOAT )
CHECK_TYPE_SIZE(double SIZE_DOUBLE )
CHECK_TYPE_SIZE("long double" SIZE_LONG_DOUBLE)
MESSAGE(STATUS "SIZE_INT=${SIZE_INT}")
MESSAGE(STATUS "SIZE_UINT=${SIZE_UINT}")
MESSAGE(STATUS "SIZE_SIZE_T=${SIZE_SIZE_T}")
MESSAGE(STATUS "SIZE_LONG=${SIZE_LONG}")
MESSAGE(STATUS "SIZE_FLOAT=${SIZE_FLOAT}")
MESSAGE(STATUS "SIZE_DOUBLE=${SIZE_DOUBLE}")
MESSAGE(STATUS "SIZE_LONG_DOUBLE=${SIZE_LONG_DOUBLE}")


# Find Feel++ or at least it dependencies
FIND_PACKAGE(Feel++ REQUIRED)

option(FEELPP_ENABLE_BAMG "Enable Bamg mesh generator in Feel++" OFF)
if(FEELPP_ENABLE_BAMG)
  add_subdirectory(contrib/bamg)
  include_directories(contrib/bamg contrib/bamg/bamglib)
  set_config_option(FEELPP_HAVE_BAMG "Bamg")
endif(FEELPP_ENABLE_BAMG)


#
# Python
#
FIND_PACKAGE(PythonInterp 2.2 REQUIRED)

#
# data
#
IF(NOT APPLE)
ADD_SUBDIRECTORY ( data )
ENDIF(NOT APPLE)

#
# Feel
#
ADD_SUBDIRECTORY ( feel )




SET(FEELPP_MESH_MAX_ORDER "5" CACHE STRING "maximum geometrical order in templates to instantiate" )

OPTION(FEELPP_ENABLE_DOCUMENTATION "enable Feel++ documentation" ON)

=== benchmarks/CMakeLists.txt ===
project( feel-benchmarks )

add_custom_target(benchmarks)
# set(petsc_SOLVER_OPTIONS "-ksp_monitor -pc_type asm -pc_asm_blocks 2" )
#set(petsc_SOLVER_OPTIONS "-pc_type lu -pc_factor_mat_solver_package umfpack" )
set(petsc_SOLVER_OPTIONS "-pc_type lu" )

# When PETSc is compiled with external direct solvers (UMFPACK, SuperLU, etc.),
# they can be selected like this:
set(petsc_LU_SOLVER_OPTIONS " -pc_type lu " )
set(petsc_LU_UMFPACK_SOLVER_OPTIONS " -pc_type lu -pc_factor_mat_solver_package umfpack -ksp_monitor " )

set(petsc_JACOBI_SOLVER_OPTIONS " -pc_type jacobi" )

#
# By default, we use the following options (GMRES with ILU(6) preconditioner and
# RCMK renumbering):
set(petsc_ILU_SOLVER_OPTIONS " -pc_type ilu -pc_factor_levels 6 -pc_factor_mat_ordering rcm " )

macro(feel_add_bench examplename)

  set(targetname feel_bench_${examplename})
  set(filename ${examplename}.cpp)
  add_executable(${targetname} ${filename})
  target_link_libraries(${targetname} ${FEELPP_LIBRARIES} )
  set_property(TARGET ${targetname} PROPERTY LABELS benchmarks)
  add_dependencies( benchmarks ${targetname} )
endmacro(feel_add_bench)

foreach( DIR laplacian  navierstokes perf wrapper/python python )
  add_subdirectory( ${DIR} )
endforeach()

=== examples/CMakeLists.txt ===
project( feel-examples )

add_custom_target( examples )
macro(feel_add_example)
  PARSE_ARGUMENTS(EXAMPLE
    "LINK_LIBRARIES;CFG;GEO"
    ""
    ${ARGN}
    )
  CAR(EXAMPLE_NAME ${EXAMPLE_DEFAULT_ARGS})
  CDR(EXAMPLE_SOURCES ${EXAMPLE_DEFAULT_ARGS})

  set(targetname feel_${EXAMPLE_NAME})
  add_executable(${targetname} ${EXAMPLE_SOURCES})
  target_link_libraries(${targetname} ${EXAMPLE_LINK_LIBRARIES} )
  set_property(TARGET ${targetname} PROPERTY LABELS examples)
  add_dependencies( examples ${targetname} )
  add_test(NAME ${targetname} COMMAND ${targetname} )
  set_property(TEST ${targetname} PROPERTY LABELS examples)
  if ( EXAMPLE_CFG )
    foreach(  cfg ${EXAMPLE_CFG} )
#      if ( EXISTS ${cfg} )
        configure_file( ${cfg} ${cfg} )
#      else()
#        message(WARNING "Examples subproject: config file ${cfg} does not exist" )
#      endif()
    endforeach()
  endif()

  if ( EXAMPLE_GEO )
    if (EXISTS $ENV{HOME})
      # create $ENV{HOME}/feel/geo if it does not exist already: this is the geometry
      # files repository
      file(MAKE_DIRECTORY $ENV{HOME}/feel/geo)

      foreach(exp ${EXAMPLE_GEO} )
        FILE(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/${exp}")
        message(STATUS ${files})
        foreach(file ${files})
          get_filename_component(filename ${file} NAME )
          add_custom_command(TARGET ${targetname}
            COMMAND ${CMAKE_COMMAND} -E copy  ${file} $ENV{HOME}/feel/geo )
          add_dependencies(${targetname} copy_mesh_data_${filename} )
        endforeach()
      endforeach()
    endif(EXISTS $ENV{HOME})
  endif()
endmacro(feel_add_example)

foreach( DIR generic heat solid snippets )
  add_subdirectory( ${DIR} )
endforeach()

=== testsuite/CMakeLists.txt ===
###  CMakeLists.txt --- 

#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-11-28
#
#  Copyright (C) 2009 Universit Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
add_custom_target( testsuite )

foreach( testdir core alg mesh poly filters material discr )
  add_subdirectory( feel${testdir} )
endforeach()

=== applications/crb/CMakeLists.txt ===
###  CMakeLists.txt ---

#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-11-12
#
#  Copyright (C) 2009 Universit Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
add_custom_target(crb)
set(FEELPP_CRB_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(FEELPP_CRB_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
include(UseCRB)

OPTION(FEELPP_ENABLE_CRB_EADS "enable EADS testcase" ON)
OPTION(FEELPP_ENABLE_CRB_HEAT1D "enable HEAT1D testcase" ON)
OPTION(FEELPP_ENABLE_CRB_RBHEAT "enable RBHEAT testcases" ON)
OPTION(FEELPP_ENABLE_CRB_AD1 "enable AD1(Advection-Diffusion) testcase" ON)
OPTION(FEELPP_ENABLE_CRB_THERMALBLOCK "enable THERMALBLOCK(many parameters) testcase" ON)
OPTION(FEELPP_ENABLE_CRB_HELMHOLTZ "enable Helmholtz testcases" ON)
OPTION(FEELPP_ENABLE_CRB_HEATSINK "enable Heatsink testcases" ON)

OPTION(FEELPP_ENABLE_CRB_ALL "enable all crb testcase" ON)
if (FEELPP_ENABLE_CRB_ALL)
  set(FEELPP_ENABLE_CRB_EADS ON)
  set(FEELPP_ENABLE_CRB_HEAT1D ON)
  set(FEELPP_ENABLE_CRB_RBHEAT ON)
  set(FEELPP_ENABLE_CRB_HEATSINK ON)
  set(FEELPP_ENABLE_CRB_AD1 ON)
  set(FEELPP_ENABLE_CRB_THERMALBLOCK ON)
  set(FEELPP_ENABLE_CRB_HELMHOLTZ ON)
endif()


IF ( FEELPP_ENABLE_CRB_EADS )
  add_subdirectory(eads)
ENDIF()


IF ( FEELPP_ENABLE_CRB_HEAT1D )
  add_subdirectory(heat1d)
  add_subdirectory(unsteady_heat1d)
ENDIF()

IF ( FEELPP_ENABLE_CRB_RBHEAT )
add_subdirectory(Rbheat)
ENDIF()

IF ( FEELPP_ENABLE_CRB_AD1 )
  add_subdirectory(advection-diffusion-2d-1)
ENDIF()


IF ( FEELPP_ENABLE_CRB_THERMALBLOCK )
  add_subdirectory(thermalblock)
ENDIF()


IF ( FEELPP_ENABLE_CRB_HELMHOLTZ )
add_subdirectory(helmholtz)
ENDIF()


if ( FEELPP_ENABLE_CRB_HEATSINK )
  add_subdirectory(heatsink-2d)
ENDIF()

=== contrib/eigen/CMakeLists.txt ===
project(Eigen)

cmake_minimum_required(VERSION 2.6.2)

# guard against in-source builds

if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(FATAL_ERROR "In-source builds not allowed. Please make a new directory (called a build directory) and run CMake from there. You may need to remove CMakeCache.txt. ")
endif()

# guard against bad build-type strings

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_tolower)
if(    NOT cmake_build_type_tolower STREQUAL "debug"
   AND NOT cmake_build_type_tolower STREQUAL "release"
   AND NOT cmake_build_type_tolower STREQUAL "relwithdebinfo")
  message(FATAL_ERROR "Unknown build type \"${CMAKE_BUILD_TYPE}\". Allowed values are Debug, Release, RelWithDebInfo (case-insensitive).")
endif()


#############################################################################
# retrieve version infomation                                               #
#############################################################################

# automatically parse the version number
file(READ "${PROJECT_SOURCE_DIR}/Eigen/src/Core/util/Macros.h" _eigen_version_header)
string(REGEX MATCH "define[ \t]+EIGEN_WORLD_VERSION[ \t]+([0-9]+)" _eigen_world_version_match "${_eigen_version_header}")
set(EIGEN_WORLD_VERSION "${CMAKE_MATCH_1}")
string(REGEX MATCH "define[ \t]+EIGEN_MAJOR_VERSION[ \t]+([0-9]+)" _eigen_major_version_match "${_eigen_version_header}")
set(EIGEN_MAJOR_VERSION "${CMAKE_MATCH_1}")
string(REGEX MATCH "define[ \t]+EIGEN_MINOR_VERSION[ \t]+([0-9]+)" _eigen_minor_version_match "${_eigen_version_header}")
set(EIGEN_MINOR_VERSION "${CMAKE_MATCH_1}")
set(EIGEN_VERSION_NUMBER ${EIGEN_WORLD_VERSION}.${EIGEN_MAJOR_VERSION}.${EIGEN_MINOR_VERSION})

# if the mercurial program is absent, this will leave the EIGEN_HG_CHANGESET string empty,
# but won't stop CMake.
execute_process(COMMAND hg tip -R ${CMAKE_SOURCE_DIR} OUTPUT_VARIABLE EIGEN_HGTIP_OUTPUT)
execute_process(COMMAND hg branch -R ${CMAKE_SOURCE_DIR} OUTPUT_VARIABLE EIGEN_BRANCH_OUTPUT)

# if this is the default (aka development) branch, extract the mercurial changeset number from the hg tip output...
if(EIGEN_BRANCH_OUTPUT MATCHES "default")
string(REGEX MATCH "^changeset: *[0-9]*:([0-9;a-f]+).*" EIGEN_HG_CHANGESET_MATCH "${EIGEN_HGTIP_OUTPUT}")
set(EIGEN_HG_CHANGESET "${CMAKE_MATCH_1}")
endif(EIGEN_BRANCH_OUTPUT MATCHES "default")
#...and show it next to the version number
if(EIGEN_HG_CHANGESET)
  set(EIGEN_VERSION "${EIGEN_VERSION_NUMBER} (mercurial changeset ${EIGEN_HG_CHANGESET})")
else(EIGEN_HG_CHANGESET)
  set(EIGEN_VERSION "${EIGEN_VERSION_NUMBER}")
endif(EIGEN_HG_CHANGESET)


include(CheckCXXCompilerFlag)

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/cmake")

#############################################################################
# find how to link to the standard libraries                                #
#############################################################################

find_package(StandardMathLibrary)

set(EIGEN_STANDARD_LIBRARIES_TO_LINK_TO "")

if(NOT STANDARD_MATH_LIBRARY_FOUND)

 # message(FATAL_ERROR
 message(STATUS
    "Can't link to the standard math library. Please report to the Eigen developers, telling them about your platform.")

else()

  if(EIGEN_STANDARD_LIBRARIES_TO_LINK_TO)
    set(EIGEN_STANDARD_LIBRARIES_TO_LINK_TO "${EIGEN_STANDARD_LIBRARIES_TO_LINK_TO} ${STANDARD_MATH_LIBRARY}")
  else()
    set(EIGEN_STANDARD_LIBRARIES_TO_LINK_TO "${STANDARD_MATH_LIBRARY}")
  endif()

endif()

if(EIGEN_STANDARD_LIBRARIES_TO_LINK_TO)
  message(STATUS "Standard libraries to link to explicitly: ${EIGEN_STANDARD_LIBRARIES_TO_LINK_TO}")
else()
  message(STATUS "Standard libraries to link to explicitly: none")
endif()

option(EIGEN_BUILD_BTL "Build benchmark suite" OFF)
if(NOT WIN32)
  option(EIGEN_BUILD_PKGCONFIG "Build pkg-config .pc file for Eigen" ON)
endif(NOT WIN32)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

option(EIGEN_SPLIT_LARGE_TESTS "Split large tests into smaller executables" ON)

option(EIGEN_DEFAULT_TO_ROW_MAJOR "Use row-major as default matrix storage order" OFF)
if(EIGEN_DEFAULT_TO_ROW_MAJOR)
  add_definitions("-DEIGEN_DEFAULT_TO_ROW_MAJOR")
endif()

add_definitions("-DEIGEN_PERMANENTLY_DISABLE_STUPID_WARNINGS")

if(CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -ansi -Wundef -Wcast-align -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -fexceptions -fno-check-new -fno-common -fstrict-aliasing")
  set(CMAKE_CXX_FLAGS_DEBUG "-g3")
  set(CMAKE_CXX_FLAGS_RELEASE "-g0 -O2")

  check_cxx_compiler_flag("-Wno-variadic-macros" COMPILER_SUPPORT_WNOVARIADICMACRO)
  if(COMPILER_SUPPORT_WNOVARIADICMACRO)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-variadic-macros")
  endif()

  check_cxx_compiler_flag("-Wextra" COMPILER_SUPPORT_WEXTRA)
  if(COMPILER_SUPPORT_WEXTRA)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra")
  endif()

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")

  option(EIGEN_TEST_SSE2 "Enable/Disable SSE2 in tests/examples" OFF)
  if(EIGEN_TEST_SSE2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
    message(STATUS "Enabling SSE2 in tests/examples")
  endif()

  option(EIGEN_TEST_SSE3 "Enable/Disable SSE3 in tests/examples" OFF)
  if(EIGEN_TEST_SSE3)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse3")
    message(STATUS "Enabling SSE3 in tests/examples")
  endif()

  option(EIGEN_TEST_SSSE3 "Enable/Disable SSSE3 in tests/examples" OFF)
  if(EIGEN_TEST_SSSE3)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mssse3")
    message(STATUS "Enabling SSSE3 in tests/examples")
  endif()

  option(EIGEN_TEST_SSE4_1 "Enable/Disable SSE4.1 in tests/examples" OFF)
  if(EIGEN_TEST_SSE4_1)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.1")
    message(STATUS "Enabling SSE4.1 in tests/examples")
  endif()

  option(EIGEN_TEST_SSE4_2 "Enable/Disable SSE4.2 in tests/examples" OFF)
  if(EIGEN_TEST_SSE4_2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.2")
    message(STATUS "Enabling SSE4.2 in tests/examples")
  endif()

  option(EIGEN_TEST_ALTIVEC "Enable/Disable AltiVec in tests/examples" OFF)
  if(EIGEN_TEST_ALTIVEC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -maltivec -mabi=altivec")
    message(STATUS "Enabling AltiVec in tests/examples")
  endif()

  option(EIGEN_TEST_NEON "Enable/Disable Neon in tests/examples" OFF)
  if(EIGEN_TEST_NEON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfloat-abi=softfp -mfpu=neon -mcpu=cortex-a8")
    message(STATUS "Enabling NEON in tests/examples")
  endif()

  check_cxx_compiler_flag("-fopenmp" COMPILER_SUPPORT_OPENMP)
  if(COMPILER_SUPPORT_OPENMP)
    option(EIGEN_TEST_OPENMP "Enable/Disable OpenMP in tests/examples" OFF)
    if(EIGEN_TEST_OPENMP)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp")
      message(STATUS "Enabling OpenMP in tests/examples")
    endif()
  endif()

endif(CMAKE_COMPILER_IS_GNUCXX)

if(MSVC)
  # C4127 - conditional expression is constant
  # C4714 - marked as __forceinline not inlined (I failed to deactivate it selectively)
  #         We can disable this warning in the unit tests since it is clear that it occurs
  #         because we are oftentimes returning objects that have a destructor or may
  #         throw exceptions - in particular in the unit tests we are throwing extra many
  #         exceptions to cover indexing errors.
  # C4505 - unreferenced local function has been removed (impossible to deactive selectively)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc /wd4127 /wd4505 /wd4714")

  # replace all /Wx by /W4
  string(REGEX REPLACE "/W[0-9]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

  check_cxx_compiler_flag("/openmp" COMPILER_SUPPORT_OPENMP)
  if(COMPILER_SUPPORT_OPENMP)
    option(EIGEN_TEST_OPENMP "Enable/Disable OpenMP in tests/examples" OFF)
    if(EIGEN_TEST_OPENMP)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /openmp")
      message(STATUS "Enabling OpenMP in tests/examples")
    endif()
  endif()

  option(EIGEN_TEST_SSE2 "Enable/Disable SSE2 in tests/examples" OFF)
  if(EIGEN_TEST_SSE2)
    if(NOT CMAKE_CL_64)
      # arch is not supported on 64 bit systems, SSE is enabled automatically.
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:SSE2")
    endif(NOT CMAKE_CL_64)
    message(STATUS "Enabling SSE2 in tests/examples")
  endif(EIGEN_TEST_SSE2)
endif(MSVC)

option(EIGEN_TEST_NO_EXPLICIT_VECTORIZATION "Disable explicit vectorization in tests/examples" OFF)
option(EIGEN_TEST_X87 "Force using X87 instructions. Implies no vectorization." OFF)
option(EIGEN_TEST_32BIT "Force generating 32bit code." OFF)

if(EIGEN_TEST_X87)
  set(EIGEN_TEST_NO_EXPLICIT_VECTORIZATION ON)
  if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfpmath=387")
    message(STATUS "Forcing use of x87 instructions in tests/examples")
  else()
    message(STATUS "EIGEN_TEST_X87 ignored on your compiler")
  endif()
endif()

if(EIGEN_TEST_32BIT)
  if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m32")
    message(STATUS "Forcing generation of 32-bit code in tests/examples")
  else()
    message(STATUS "EIGEN_TEST_32BIT ignored on your compiler")
  endif()
endif()

if(EIGEN_TEST_NO_EXPLICIT_VECTORIZATION)
  add_definitions(-DEIGEN_DONT_VECTORIZE=1)
  message(STATUS "Disabling vectorization in tests/examples")
endif()

option(EIGEN_TEST_NO_EXPLICIT_ALIGNMENT "Disable explicit alignment (hence vectorization) in tests/examples" OFF)
if(EIGEN_TEST_NO_EXPLICIT_ALIGNMENT)
  add_definitions(-DEIGEN_DONT_ALIGN=1)
  message(STATUS "Disabling alignment in tests/examples")
endif()

option(EIGEN_TEST_C++0x "Enables all C++0x features." OFF)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

# the user modifiable install path for header files
set(EIGEN_INCLUDE_INSTALL_DIR "include/feel" CACHE PATH "The directory where we install the header files (optional)")

# set the internal install path for header files which depends on wether the user modifiable
# EIGEN_INCLUDE_INSTALL_DIR has been set by the user or not.
if(EIGEN_INCLUDE_INSTALL_DIR)
  set(INCLUDE_INSTALL_DIR
    "include/feel"
    CACHE INTERNAL
    "The directory where we install the header files (internal)"
  )
else()
  set(INCLUDE_INSTALL_DIR
    "${CMAKE_INSTALL_PREFIX}/include/feel"
    CACHE INTERNAL
    "The directory where we install the header files (internal)"
  )
endif()

# similar to set_target_properties but append the property instead of overwriting it
macro(ei_add_target_property target prop value)

  get_target_property(previous ${target} ${prop})
  # if the property wasn't previously set, ${previous} is now "previous-NOTFOUND" which cmake allows catching with plain if()
  if(NOT previous)
    set(previous "")
  endif(NOT previous)
  set_target_properties(${target} PROPERTIES ${prop} "${previous} ${value}")
endmacro(ei_add_target_property)

install(FILES
  signature_of_eigen3_matrix_library
  DESTINATION ${INCLUDE_INSTALL_DIR} COMPONENT Devel
  )

if(EIGEN_BUILD_PKGCONFIG)
    configure_file(eigen3.pc.in eigen3.pc)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/eigen3.pc
        DESTINATION share/pkgconfig
        )
endif(EIGEN_BUILD_PKGCONFIG)

add_subdirectory(Eigen)

add_subdirectory(doc EXCLUDE_FROM_ALL)

# add_custom_target(buildtests)
# add_custom_target(check COMMAND "ctest")
# add_dependencies(check buildtests)

# CMake/Ctest does not allow us to change the build command,
# so we have to workaround by directly editing the generated DartConfiguration.tcl file
# save CMAKE_MAKE_PROGRAM
set(CMAKE_MAKE_PROGRAM_SAVE ${CMAKE_MAKE_PROGRAM})
# and set a fake one
set(CMAKE_MAKE_PROGRAM "@EIGEN_MAKECOMMAND_PLACEHOLDER@")

# include(CTest)
# enable_testing() # must be called from the root CMakeLists, see man page
# include(EigenTesting)
# ei_init_testing()

# # overwrite default DartConfiguration.tcl

=== examples/snippets/CMakeLists.txt ===
###  TEMPLATE.txt.tpl; coding: utf-8 ---

#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2011-03-15
#
#  Copyright (C) 2011 Universit Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
feel_add_example( dofpoints dofpoints.cpp LINK_LIBRARIES ${FEELPP_LIBRARIES})
feel_add_example( meshho meshho.cpp LINK_LIBRARIES ${FEELPP_LIBRARIES})
feel_add_example( bdfpod bdfpod.cpp LINK_LIBRARIES ${FEELPP_LIBRARIES})
feel_add_example( perf_int perf.cpp LINK_LIBRARIES ${FEELPP_LIBRARIES} )

=== examples/solid/CMakeLists.txt ===
###  CMakeLists.txt ---

#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-11-11
#
#  Copyright (C) 2009 Universit Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#

feel_add_example(beam beam.cpp LINK_LIBRARIES ${FEELPP_LIBRARIES})
feel_add_example(stvenant_kirchhoff stvenant_kirchhoff.cpp LINK_LIBRARIES ${FEELPP_LIBRARIES})
feel_add_example(axi_1D axi_1D.cpp LINK_LIBRARIES ${FEELPP_LIBRARIES})

=== feel/feelalg/CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8 -*-
#
#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-11-29
#
#  Copyright (C) 2009-2010 Université Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
if( PETSC_FOUND )
  set( FEELPP_PETSC_SRCS vectorpetsc.cpp matrixpetsc.cpp solverlinearpetsc.cpp solvernonlinearpetsc.cpp functionspetsc.cpp preconditionerpetsc.cpp)

  if ( FEELPP_HAS_SLEPC )
    set( FEELPP_SLEPC_SRCS solvereigenslepc.cpp )
  endif()
endif()

if ( TRILINOS_LIBRARIES )
  set( FEELPP_TRILINOS_SRCS vectorepetra.cpp matrixepetra.cpp preconditionerml.cpp preconditionerifpack.cpp backendtrilinos.cpp solvernonlineartrilinos.cpp )
endif()

set( SRC
  dummy.cpp datamap.cpp
  vector.cpp vectorublas.cpp
  preconditioner.cpp
  backend.cpp  matrixshellsparse.cpp backend_adaptive_reuse_pc.cpp backendpetsc.cpp
  graphcsr.cpp  solvereigen.cpp
  solvernonlinear.cpp matrixblock.cpp vectorblock.cpp
  ${FEELPP_PETSC_SRCS}
  ${FEELPP_SLEPC_SRCS}
  ${FEELPP_TRILINOS_SRCS}
  )


file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.hpp)
feel_append_src(feelalg "${SRC};${HDR}")

=== feel/feelcrb/CMakeLists.txt ===
###  CMakeLists.txt ---

#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-11-13
#
#  Copyright (C) 2009 Universit Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
# set(CMAKE_CXX_FLAGS "-g -O0" )

set(SRC crb.cpp crbdb.cpp crbscm.cpp pfemapp.cpp opusapp.cpp )


file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.hpp)
feel_append_src(feelcrb "${SRC};${HDR}")

=== feel/feelfilters/CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8 -*-
#
#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-11-29
#
#  Copyright (C) 2009-2010 Université Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
IF ( ENABLE_INSTANTIATION_MODE )
  SET( FEELFILTERS_INST_SRCS

    # exporterensight.cpp exportergmsh.cpp # exportergnuplot.cpp
    )
  endif()

SET(SRC
  gmshhypercubedomain.cpp gmshsimplexdomain.cpp gmshellipsoiddomain.cpp
  #exporterfactorysimplex.cpp exporterfactoryhypercube.cpp
  exporter.cpp gmsh.cpp importergambit.cpp ${FEELFILTERS_INST_SRCS} geotool.cpp
  )

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.hpp)
feel_append_src(feelfilters "${SRC};${HDR}")

=== testsuite/feeldiscr/CMakeLists.txt ===
foreach(TEST elementminmax project bdf interpolation integration integration_ho integration_ifaces space geomap mixed
             auto_order_integrate interp_twomesh submesh disc vect_comp operatorinterpolation normal3d aitken form_interpolation integration_opt lift trace
             form_severaltrialtestmesh hcurl wire_basket)

  feel_add_test( ${TEST} )

endforeach()


add_custom_command(OUTPUT geo  COMMAND ${CMAKE_COMMAND} ARGS -E copy ${CMAKE_CURRENT_SOURCE_DIR}/test_integration_ho_geometry.geo ${CMAKE_CURRENT_BINARY_DIR} )
add_custom_target(data DEPENDS geo)
add_dependencies(test_integration_ho data)

=== debian/changelog ===
feel++ (0.91.4-3) unstable; urgency=low

  [ Christophe Prud'homme ]
  * debian/control: update Standards-Version to 3.9.3 (no change)
  * debian/rules: revert back to g++-4.6, g++-4.7 is too broken
  
  [ Dmitrijs Ledkovs ]
  * debian/control: remove alternative dependencies on libboost1.46-* in
    the libfeel++-dev package. BinNMUs can and have transitioned the
    package to boost1.49 by now, so the dependency should only be on the
    default boost packages. This will get the package 'unstuck' in the
    boost1.49 transition tracker.

  [ Daniel Leidert ]
  * debian/watch: sent watch file patch for google code

 -- Christophe Prud'homme <prudhomm@debian.org>  Mon, 11 Jun 2012 00:32:51 +0200

feel++ (0.91.4-2) unstable; urgency=low

  * debian/control: openturns-wrapper no longer exists, do no depend on it
    anymore

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 20 May 2012 21:48:47 +0200

feel++ (0.91.4-1) unstable; urgency=low

  [ Christophe Prud'homme ]
  * New upstream release
  * debian/{control,rules}: remove trilinos deps and support

 -- Christophe Prud'homme <prudhomm@debian.org>  Sat, 19 May 2012 00:03:11 +0200

feel++ (0.91.3-4) unstable; urgency=low

  * debian/control: depend only on slepc which depend on petsc and depend
    on slepc3.1(hence petsc3.1) as well as slepc3.2 (hence petsc3.2). This
    change should allow to compile on Ubuntu.

 -- Christophe Prud'homme <prudhomm@debian.org>  Sat, 07 Apr 2012 07:42:58 +0200

feel++ (0.91.3-3) unstable; urgency=low

  * debian/copyright: update.
  * debian/control: remove some build-depends (e.g. python-{pyx,scipy})
    that are no longer necessary
  * debian/control: only build for amd64, i386 ia64, powerpc and
    sparc. The other architectures are not targets for feel++ which
    requires a lot of memory to compile.

 -- Christophe Prud'homme <prudhomm@debian.org>  Wed, 04 Apr 2012 12:04:06 +0200

feel++ (0.91.3-2) unstable; urgency=low

  * debian/rules: remove sparc specific config 

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 03 Apr 2012 10:05:33 +0200

feel++ (0.91.3-1) unstable; urgency=low

  * New upstream release

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 03 Apr 2012 09:10:57 +0200

feel++ (0.91.2-1) unstable; urgency=low

  * New upstream release

 -- Christophe Prud'homme <prudhomm@debian.org>  Mon, 02 Apr 2012 23:32:28 +0200

=== debian/control ===
Source: feel++
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>
Build-Depends: cdbs, quilt, debhelper (>= 7), cmake (>=2.6), g++-4.6, gfortran (>=4.5),
	       libboost-all-dev, libboost-mpi-dev,
	       mpi-default-dev[!hurd-i386], mpi-default-bin[!hurd-i386],
	       libslepc3.2-dev|libslepc3.1-dev,
	       libhdf5-mpi-dev (>= 1.8.8),
	       libxml2-dev,
	       gmsh, 
               doxygen, doxygen-latex,
	       transfig,imagemagick,
	       libtbb-dev[amd64 i386],
	       libopenturns-dev, libann-dev, libglpk-dev 
Standards-Version: 3.9.3
Homepage: http://www.feelpp.org
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/feel++/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/feel++/trunk


Package: libfeel++1
Section: libs
Architecture: amd64 i386 ia64 powerpc sparc
Depends: ${shlibs:Depends}, ${misc:Depends}, gmsh
Replaces: liblife
Description: A library for the finite element method
 This package provides the dynamic Feel++ libraries.
 .
 Feel++ is a versatile finite element library to solve partial
 differential equations.
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration


Package: libfeel++-dev
Section: libdevel
Architecture: amd64 i386 ia64 powerpc sparc
Depends: ${shlibs:Depends}, ${misc:Depends}, mpi-default-dev, libfeel++1 (= ${binary:Version}), libvtk5-dev, 
	 libboost-all-dev, libboost-mpi-dev,
	 mpi-default-dev, mpi-default-bin,
	 libslepc3.2-dev|libslepc3.1-dev, 
	 libeigen2-dev, libvtk5-dev, libxml2-dev, libtbb-dev [amd64 i386],
         libopenturns-dev, libann-dev, libglpk-dev
Suggests: feel++-doc, libfeel++-dbg, doxygen, cmake, cmake-curses-gui
Replaces: liblife-dev
Description: A library for the finite element method
 This package provides the header files and static libraries.
 .
 Feel++ is a versatile finite element library to solve partial
 differential equations.
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration

Package: libfeel++-dbg
Section: debug
Architecture: amd64 i386 ia64 powerpc sparc
Depends: ${shlibs:Depends}, ${misc:Depends}, mpi-default-dev, libfeel++-dev, libtbb2-dbg [amd64 i386]
Replaces: liblife-dbg
Description: A library for the finite element method
 Feel++ is a versatile finite element library to solve partial
 differential equations
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration

Package: feel++-apps
Section: science
Architecture: amd64 i386 ia64 powerpc sparc
Depends: ${shlibs:Depends}, ${misc:Depends}, libfeel++1 (= ${binary:Version}), gmsh
Recommends: paraview
Replaces: life-apps
Description: A library for the finite element method
 This package provides some applications codes(source and executables) such
 as laplacian with cG and dG methods, stokes, heat transfer, solid
 mechanics(static and dynamic).
 .
 Feel++ is a versatile finite element library to solve partial
 differential equations
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration

Package: feel++-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Replaces: life-doc
Description: A library for the finite element method
 This package provides the documentation for the Feel++ library : a user
 guide including a tutorial and the api documentation generated by
 doxygen.
 .
 Feel++ is a versatile finite element library to solve partial
 differential equations.
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration

=== debian/rules ===
#!/usr/bin/make -f

DEB_AUTO_CLEANUP_RCS   := yes
DEB_COMPRESS_EXCLUDE   := .pdf


include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk

export CXX=/usr/bin/g++-4.6
export CFLAGS=
export CXXFLAGS=

DEB_BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_BUILD_ARCH_OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
DEB_BUILD_GNU_SYSTEM ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_SYSTEM)
PETSC_ARCH=$(DEB_BUILD_GNU_SYSTEM)

FEELPP_INSTALL_ENABLERS=-DBUILD_TESTING=OFF                  \
		      -DFEELPP_ENABLE_DOCUMENTATION=ON       \
                      -DFEELPP_MINIMAL_CONFIGURATION=ON

DEB_CMAKE_EXTRA_FLAGS=                      \
        -DCMAKE_CXX_COMPILER=/usr/bin/g++-4.6 \
        -DCMAKE_BUILD_TYPE=Release          \
	-DCMAKE_CXX_FLAGS_RELEASE="-O2 -DNDEBUG -g0"  \
	-DPETSC_ARCH=$(PETSC_ARCH)-c-opt        \
	-DPETSC_DIR=/usr/lib/petscdir/3.2 \
	-DPETSC_EXECUTABLE_RUNS=ON          \
	-DFEELPP_ENABLE_TRILINOS=OFF      \
	-DFEELPP_ENABLE_APPLICATIONS=OFF      \
	-DFEELPP_ENABLE_APPLICATIONS_CRB=ON      \
	-DFEELPP_ENABLE_BENCHMARKS=OFF        \
	-DFEELPP_ENABLE_TESTS=OFF             \
	-DFEELPP_ENABLE_EXAMPLES=OFF          \
	-DFEELPP_OPUS_ENABLE_EADS=ON        \
	${FEELPP_INSTALL_ENABLERS}            \
	-DTRILINOS_LIB_NOXLAPACK=           \
	-DFEELPP_ENABLE_INSTANTIATION_MODE=OFF \
	$(CURDIR)/$(DEB_SRCDIR) 


#build/feel++-apps::
#	-cd $(DEB_BUILDDIR) && ctest -D Experimental

#build/libfeel++::
#	-cd $(DEB_BUILDDIR) && make doc

build/feel++-doc::
	-cd $(DEB_BUILDDIR)/doc/api && make doxygen

binary-install/feel++-apps::
	strip debian/feel++-apps/usr/bin/*

get-orig-source:
	uscan --force-download
